#include "DAQMessages/DDTMessagesDcps_impl.h"
#include "gapi.h"
#include "gapi_loanRegistry.h"
#include "DAQMessages/DDTMessagesSplDcps.h"
#include "ccpp_DataReader_impl.h"
#include "ccpp_DataReaderView_impl.h"


extern c_bool
__ddtmessages_DDTTriggerMessage__copyIn(
    c_base base,
    struct ddtmessages::DDTTriggerMessage *from,
    struct _ddtmessages_DDTTriggerMessage *to);

extern void
__ddtmessages_DDTTriggerMessage__copyOut(
    void *_from,
    void *_to);

// DDS ddtmessages::DDTTriggerMessage TypeSupportFactory Object Body

 DDS::DataWriter_ptr 
ddtmessages::DDTTriggerMessageTypeSupportFactory::create_datawriter (gapi_dataWriter handle)
{
    return new ddtmessages::DDTTriggerMessageDataWriter_impl(handle);
}

 DDS::DataReader_ptr 
ddtmessages::DDTTriggerMessageTypeSupportFactory::create_datareader (gapi_dataReader handle)
{
    return new ddtmessages::DDTTriggerMessageDataReader_impl (handle);
}


 DDS::DataReaderView_ptr 
ddtmessages::DDTTriggerMessageTypeSupportFactory::create_view (gapi_dataReaderView handle)
{
    return new ddtmessages::DDTTriggerMessageDataReaderView_impl (handle);
}

// DDS ddtmessages::DDTTriggerMessage TypeSupport Object Body

 ddtmessages::DDTTriggerMessageTypeSupport::DDTTriggerMessageTypeSupport(void) :
    TypeSupport_impl(
        __ddtmessages_DDTTriggerMessage__name(),
        __ddtmessages_DDTTriggerMessage__keys(),
        ddtmessages::DDTTriggerMessageTypeSupport::metaDescriptor,
        (gapi_copyIn) __ddtmessages_DDTTriggerMessage__copyIn,
        (gapi_copyOut) __ddtmessages_DDTTriggerMessage__copyOut,
        (gapi_readerCopy) DDS::ccpp_DataReaderCopy<ddtmessages::DDTTriggerMessageSeq, ddtmessages::DDTTriggerMessage>,
        new  ddtmessages::DDTTriggerMessageTypeSupportFactory())
{
    // Parent constructor takes care of everything.
}

 ddtmessages::DDTTriggerMessageTypeSupport::~DDTTriggerMessageTypeSupport(void)
{
    // Parent destructor takes care of everything.
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageTypeSupport::register_type(
    DDS::DomainParticipant_ptr domain,
    const char * type_name) THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::register_type(domain, type_name);
}

 char *
ddtmessages::DDTTriggerMessageTypeSupport::get_type_name() THROW_ORB_EXCEPTIONS
{
    return TypeSupport_impl::get_type_name();
}

// DDS ddtmessages::DDTTriggerMessage DataWriter_impl Object Body

 ddtmessages::DDTTriggerMessageDataWriter_impl::DDTTriggerMessageDataWriter_impl (
    gapi_dataWriter handle
) : DDS::DataWriter_impl(handle)
{
    // Parent constructor takes care of everything.
}

 ddtmessages::DDTTriggerMessageDataWriter_impl::~DDTTriggerMessageDataWriter_impl(void)
{
    // Parent destructor takes care of everything.
}

 DDS::InstanceHandle_t
ddtmessages::DDTTriggerMessageDataWriter_impl::register_instance(
    const ddtmessages::DDTTriggerMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance(&instance_data);
}

 DDS::InstanceHandle_t 
ddtmessages::DDTTriggerMessageDataWriter_impl::register_instance_w_timestamp(
    const DDTTriggerMessage & instance_data,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::register_instance_w_timestamp(&instance_data, source_timestamp);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::unregister_instance(
    const ddtmessages::DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance(&instance_data, handle);
}

 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataWriter_impl::unregister_instance_w_timestamp(
    const DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::unregister_instance_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::write(
    const ddtmessages::DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write(&instance_data, handle);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::write_w_timestamp(
    const DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::write_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::dispose(
    const ddtmessages::DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose(&instance_data, handle);
}

 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataWriter_impl::dispose_w_timestamp(
    const DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::dispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::writedispose(
    const ddtmessages::DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose(&instance_data, handle);
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataWriter_impl::writedispose_w_timestamp(
    const DDTTriggerMessage & instance_data,
    DDS::InstanceHandle_t handle,
    const DDS::Time_t & source_timestamp) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::writedispose_w_timestamp(&instance_data, handle, source_timestamp);
}

 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataWriter_impl::get_key_value(
    DDTTriggerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
ddtmessages::DDTTriggerMessageDataWriter_impl::lookup_instance(
	const ddtmessages::DDTTriggerMessage & instance_data) THROW_ORB_EXCEPTIONS
{
    return DataWriter_impl::lookup_instance(&instance_data);
}

// DDS ddtmessages::DDTTriggerMessage DataReader_impl Object Body

 ddtmessages::DDTTriggerMessageDataReader_impl::DDTTriggerMessageDataReader_impl (
    gapi_dataReader handle
) : DDS::DataReader_impl(handle)
{
    // Parent constructor takes care of everything.
}

 ddtmessages::DDTTriggerMessageDataReader_impl::~DDTTriggerMessageDataReader_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::read(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::take(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::read_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::take_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::read_next_sample(
    ddtmessages::DDTTriggerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::take_next_sample(
    ddtmessages::DDTTriggerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::read_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::take_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::read_next_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::take_next_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::read_next_instance_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::take_next_instance_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReader_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReader_impl::return_loan(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReader_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        ddtmessages::DDTTriggerMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::get_key_value(
    ddtmessages::DDTTriggerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
ddtmessages::DDTTriggerMessageDataReader_impl::lookup_instance(
    const ddtmessages::DDTTriggerMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReader_impl::lookup_instance(&instance);
}

 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples)
{
    DDS::ReturnCode_t status = DDS::RETCODE_PRECONDITION_NOT_MET;
    
    if ( received_data.length() == info_seq.length() &&
         received_data.maximum() == info_seq.maximum() &&
         received_data.release() == info_seq.release() ) {
        if ( received_data.maximum() == 0 || received_data.release() ) {
            if (received_data.maximum() == 0 ||
				max_samples <= static_cast<CORBA::Long>(received_data.maximum()) ||
				max_samples == DDS::LENGTH_UNLIMITED ) {
                status = DDS::RETCODE_OK;
            }
        }
    }
    return status;
}


// DDS ddtmessages::DDTTriggerMessage DataReaderView_impl Object Body

 ddtmessages::DDTTriggerMessageDataReaderView_impl::DDTTriggerMessageDataReaderView_impl (
    gapi_dataReaderView handle
) : DDS::DataReaderView_impl(handle)
{
    // Parent constructor takes care of everything.
}

 ddtmessages::DDTTriggerMessageDataReaderView_impl::~DDTTriggerMessageDataReaderView_impl(void)
{
    // Parent destructor takes care of everything.
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::read(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::take(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take(&received_data, info_seq, max_samples, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::read_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::take_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_w_condition(&received_data, info_seq, max_samples, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::read_next_sample(
    ddtmessages::DDTTriggerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::read_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::take_next_sample(
    ddtmessages::DDTTriggerMessage & received_data,
    DDS::SampleInfo & sample_info) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::take_next_sample(&received_data, sample_info);
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::read_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::take_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::read_next_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}

 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::take_next_instance(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::SampleStateMask sample_states,
    DDS::ViewStateMask view_states,
    DDS::InstanceStateMask instance_states) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance(&received_data, info_seq, max_samples, a_handle, sample_states, view_states, instance_states);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::read_next_instance_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::read_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::take_next_instance_w_condition(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq,
    CORBA::Long max_samples,
    DDS::InstanceHandle_t a_handle,
    DDS::ReadCondition_ptr a_condition) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status;
    
    status = ddtmessages::DDTTriggerMessageDataReader_impl::check_preconditions(received_data, info_seq, max_samples);
    if ( status == DDS::RETCODE_OK ) {
        status = DataReaderView_impl::take_next_instance_w_condition(&received_data, info_seq, max_samples, a_handle, a_condition);
    }
    return status;
}


 DDS::ReturnCode_t
ddtmessages::DDTTriggerMessageDataReaderView_impl::return_loan(
    ddtmessages::DDTTriggerMessageSeq & received_data,
    DDS::SampleInfoSeq & info_seq) THROW_ORB_EXCEPTIONS
{
    DDS::ReturnCode_t status = DDS::RETCODE_OK;

    if ( received_data.length() > 0 ) {
        if (received_data.length() == info_seq.length() && 
            received_data.release() == info_seq.release() ) {
            if (!received_data.release()) {
                status = DataReaderView_impl::return_loan( received_data.get_buffer(),
                                                       info_seq.get_buffer() );

                if ( status == DDS::RETCODE_OK ) {
                    if ( !received_data.release() ) {
                        ddtmessages::DDTTriggerMessageSeq::freebuf( received_data.get_buffer(false) );
                        received_data.replace(0, 0, NULL, false);
                        DDS::SampleInfoSeq::freebuf( info_seq.get_buffer(false) );
                        info_seq.replace(0, 0, NULL, false);
                    }
                } else if ( status == DDS::RETCODE_NO_DATA ) {
                    if ( received_data.release() ) {
                        status = DDS::RETCODE_OK;
                    } else {
                        status = DDS::RETCODE_PRECONDITION_NOT_MET;
                    }
                }
            }
        } else {
            status = DDS::RETCODE_PRECONDITION_NOT_MET;
        }
    }
    return status;
}


 DDS::ReturnCode_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::get_key_value(
    ddtmessages::DDTTriggerMessage & key_holder,
    DDS::InstanceHandle_t handle) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::get_key_value(&key_holder, handle);
}

 DDS::InstanceHandle_t 
ddtmessages::DDTTriggerMessageDataReaderView_impl::lookup_instance(
    const ddtmessages::DDTTriggerMessage & instance) THROW_ORB_EXCEPTIONS
{
    return DataReaderView_impl::lookup_instance(&instance);
}



const char * ::ddtmessages::DDTTriggerMessageTypeSupport::metaDescriptor = "<MetaData version=\"1.0.0\"><Module name=\"rmscore\"><Struct name=\"TimeStruct\"><Member name=\"sec\"><ULong/></Member><Member name=\"usec\"><ULong/></Member></Struct><Struct name=\"RmsMessageHeader\"><Member name=\"target\"><String/></Member><Member name=\"channel\"><String/></Member><Member name=\"replyTarget\"><String/></Member><Member name=\"id\"><String/></Member><Member name=\"correlationId\"><String/></Member><Member name=\"sentTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"correlationTime\"><Type name=\"rmscore::TimeStruct\"/></Member><Member name=\"priority\"><Long/></Member><Member name=\"partitionNumber\"><Long/></Member><Member name=\"hostName\"><String/></Member><Member name=\"applicationName\"><String/></Member></Struct></Module><Module name=\"ddtmessages\"><Struct name=\"DDTTriggerMessage\"><Member name=\"header\"><Type name=\"rmscore::RmsMessageHeader\"/></Member><Member name=\"trigger_type\"><Long/></Member><Member name=\"prescale\"><ULong/></Member><Member name=\"decision_time\"><LongLong/></Member><Member name=\"time_to_decision\"><Long/></Member><Member name=\"start_time\"><LongLong/></Member><Member name=\"duration\"><Long/></Member><Member name=\"detector_id\"><Short/></Member><Member name=\"buffer_node_id\"><Short/></Member><Member name=\"process_id\"><Long/></Member><Member name=\"enabled\"><Boolean/></Member></Struct></Module></MetaData>";
