#include "DAQMessages/GTMessagesSplDcps.h"
#include "DAQMessages/ccpp_GTMessages.h"

char *
__triggermessages_TriggerMessage__name(void)
{
    return CORBA::string_dup("triggermessages::TriggerMessage");
}

char *
__triggermessages_TriggerMessage__keys(void)
{
    return CORBA::string_dup("header.hostName,header.replyTarget");
}

char *
__triggermessages_TriggerReply__name(void)
{
    return CORBA::string_dup("triggermessages::TriggerReply");
}

char *
__triggermessages_TriggerReply__keys(void)
{
    return CORBA::string_dup("header.hostName,header.replyTarget");
}

#include <v_kernel.h>
#include <v_topic.h>
#include <os_stdlib.h>
#include <string.h>

c_bool
__triggermessages_TriggerMessage__copyIn(
    c_base base,
    struct ::triggermessages::TriggerMessage *from,
    struct _triggermessages_TriggerMessage *to)
{
    c_bool result = TRUE;

    if(result){
        extern c_bool __rmscore_RmsMessageHeader__copyIn(c_base, ::rmscore::RmsMessageHeader *, _rmscore_RmsMessageHeader *);
        result = __rmscore_RmsMessageHeader__copyIn(base, &from->header, &to->header);
    }
    if(result){
        extern c_bool __rmscore_SequenceOfOctet__copyIn(c_base, ::rmscore::SequenceOfOctet *, _rmscore_SequenceOfOctet *);
        result = __rmscore_SequenceOfOctet__copyIn(base, &from->payload, &to->payload);
    }
    return result;
}

c_bool
__triggermessages_TriggerReply__copyIn(
    c_base base,
    struct ::triggermessages::TriggerReply *from,
    struct _triggermessages_TriggerReply *to)
{
    c_bool result = TRUE;

    if(result){
        extern c_bool __rmscore_RmsMessageHeader__copyIn(c_base, ::rmscore::RmsMessageHeader *, _rmscore_RmsMessageHeader *);
        result = __rmscore_RmsMessageHeader__copyIn(base, &from->header, &to->header);
    }
    if(result){
        extern c_bool __rmscore_RequestStatus__copyIn(c_base, ::rmscore::RequestStatus *, _rmscore_RequestStatus *);
        result = __rmscore_RequestStatus__copyIn(base, &from->status, &to->status);
    }
    return result;
}

void
__triggermessages_TriggerMessage__copyOut(
    void *_from,
    void *_to)
{
    struct _triggermessages_TriggerMessage *from = (struct _triggermessages_TriggerMessage *)_from;
    struct ::triggermessages::TriggerMessage *to = (struct ::triggermessages::TriggerMessage *)_to;
    {
        extern void __rmscore_RmsMessageHeader__copyOut(void *, void *);
        __rmscore_RmsMessageHeader__copyOut((void *)&from->header, (void *)&to->header);
    }
    {
        extern void __rmscore_SequenceOfOctet__copyOut(void *, void *);
        __rmscore_SequenceOfOctet__copyOut((void *)&from->payload, (void *)&to->payload);
    }
}

void
__triggermessages_TriggerReply__copyOut(
    void *_from,
    void *_to)
{
    struct _triggermessages_TriggerReply *from = (struct _triggermessages_TriggerReply *)_from;
    struct ::triggermessages::TriggerReply *to = (struct ::triggermessages::TriggerReply *)_to;
    {
        extern void __rmscore_RmsMessageHeader__copyOut(void *, void *);
        __rmscore_RmsMessageHeader__copyOut((void *)&from->header, (void *)&to->header);
    }
    {
        extern void __rmscore_RequestStatus__copyOut(void *, void *);
        __rmscore_RequestStatus__copyOut((void *)&from->status, (void *)&to->status);
    }
}

