#ifndef NSNMESSAGESSPLTYPES_H
#define NSNMESSAGESSPLTYPES_H

#include "DAQMessages/ccpp_NSNMessages.h"

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>

#include "rms/RmsMessageCoreSplDcps.h"

extern c_metaObject __NSNMessages_nsnmessages__load (c_base base);

extern c_metaObject __nsnmessages_NSNMessage__load (c_base base);
extern char * __nsnmessages_NSNMessage__keys (void);
extern char * __nsnmessages_NSNMessage__name (void);
struct _nsnmessages_NSNMessage ;
extern  c_bool __nsnmessages_NSNMessage__copyIn(c_base base, struct nsnmessages::NSNMessage *from, struct _nsnmessages_NSNMessage *to);
extern  void __nsnmessages_NSNMessage__copyOut(void *_from, void *_to);
struct _nsnmessages_NSNMessage {
    struct _rmscore_RmsMessageHeader header;
    c_longlong time;
    c_long hits;
};

extern c_metaObject __nsnmessages_NSNPackedMessage__load (c_base base);
extern char * __nsnmessages_NSNPackedMessage__keys (void);
extern char * __nsnmessages_NSNPackedMessage__name (void);
struct _nsnmessages_NSNPackedMessage ;
extern  c_bool __nsnmessages_NSNPackedMessage__copyIn(c_base base, struct nsnmessages::NSNPackedMessage *from, struct _nsnmessages_NSNPackedMessage *to);
extern  void __nsnmessages_NSNPackedMessage__copyOut(void *_from, void *_to);
struct _nsnmessages_NSNPackedMessage {
    struct _rmscore_RmsMessageHeader header;
    c_longlong time[10];
    c_long hits[10];
};

#endif
