#include "DAQMessages/SNEWSMessagesSplDcps.h"
#include "DAQMessages/ccpp_SNEWSMessages.h"

char *
__nsimessages_SNEWSMessage__name(void)
{
    return CORBA::string_dup("nsimessages::SNEWSMessage");
}

char *
__nsimessages_SNEWSMessage__keys(void)
{
    return CORBA::string_dup("header.hostName,header.replyTarget");
}

#include <v_kernel.h>
#include <v_topic.h>
#include <os_stdlib.h>
#include <string.h>

c_bool
__nsimessages_SNEWSMessage__copyIn(
    c_base base,
    struct ::nsimessages::SNEWSMessage *from,
    struct _nsimessages_SNEWSMessage *to)
{
    c_bool result = TRUE;

    if(result){
        extern c_bool __rmscore_RmsMessageHeader__copyIn(c_base, ::rmscore::RmsMessageHeader *, _rmscore_RmsMessageHeader *);
        result = __rmscore_RmsMessageHeader__copyIn(base, &from->header, &to->header);
    }
    to->time = (c_longlong)from->time;
    to->type = (c_long)from->type;
    return result;
}

void
__nsimessages_SNEWSMessage__copyOut(
    void *_from,
    void *_to)
{
    struct _nsimessages_SNEWSMessage *from = (struct _nsimessages_SNEWSMessage *)_from;
    struct ::nsimessages::SNEWSMessage *to = (struct ::nsimessages::SNEWSMessage *)_to;
    {
        extern void __rmscore_RmsMessageHeader__copyOut(void *, void *);
        __rmscore_RmsMessageHeader__copyOut((void *)&from->header, (void *)&to->header);
    }
    to->time = (::DDS::LongLong)from->time;
    to->type = (::DDS::Long)from->type;
}

